class String
    def permalink
      s = self.downcase
      String.transiterate_table.each{|from,to| s = s.gsub(from,to)}
      s = s.gsub(/[^a-zA-Z0-9\-]/, '-')
      s = s.gsub(/--/, '-')
      s = s.gsub(/-$/, '')
      
      return s
    end

    def equal_as_id(s)
      s1 = String.new self
      s1 = s1.downcase.strip
      s2 = s.downcase.strip
      return (s1 == s2)
    end
    
    def md5
      Digest::MD5.hexdigest("--SnowDB salt, some other shit and so on--#{self}")
    end
    
    def String.transiterate_table 
      tbl = {
        'а' => 'a',
        'б' => 'b',
        'в' => 'v',
        'г' => 'g',
        'д' => 'd',
        'е' => 'e',
        'ё' => 'e',
        'ж' => 'zh',
        'з' => 'z',
        'и' => 'i',
        'й' => 'y',
        'к' => 'k',
        'л' => 'l',
        'м' => 'm',
        'н' => 'n',
        'о' => 'o',
        'п' => 'p',
        'р' => 'r',
        'с' => 's',
        'т' => 't',
        'у' => 'u',
        'ф' => 'f',
        'х' => 'h',
        'ц' => 'c',
        'ч' => 'ch',
        'ш' => 'sh',
        'щ' => 'sh',
        'ъ' => '',
        'ы' => 'y',
        'ь' => '',
        'э' => 'e',
        'ю' => 'yu',
        'я' => 'ya',
        'А' => 'a',
        'Б' => 'b',
        'В' => 'v',
        'Г' => 'g',
        'Д' => 'd',
        'Е' => 'e',
        'Ё' => 'e',
        'Ж' => 'zh',
        'З' => 'z',
        'И' => 'i',
        'Й' => 'y',
        'К' => 'k',
        'Л' => 'l',
        'М' => 'm',
        'Н' => 'n',
        'О' => 'o',
        'П' => 'p',
        'Р' => 'r',
        'С' => 's',
        'Т' => 't',
        'У' => 'u',
        'Ф' => 'f',
        'Х' => 'h',
        'Ц' => 'c',
        'Ч' => 'ch',
        'Ш' => 'sh',
        'Щ' => 'sh',
        'Ъ' => '',
        'Ы' => 'y',
        'Ь' => '',
        'Э' => 'e',
        'Ю' => 'yu',
        'Я' => 'ya'
      }
  end  

end